package com.perforce.hws.testing;

import org.testng.annotations.AfterSuite;
import org.testng.annotations.BeforeSuite;

import com.perforce.hws.automation.Basic15_2EnvironmentSetup;

import java.io.IOException;

/**
 * Created by tjuricek on 3/10/16.
 */
public class Basic15_2EnvironmentTestSetup implements SuiteCleanupHelpers {

    Basic15_2EnvironmentSetup setup = null;

    @BeforeSuite(dependsOnGroups = "log4j")
    public void runBasicEnvironmentSetup() throws IOException {
        try {
            if (setup == null) {
                setup = new Basic15_2EnvironmentSetup();
            }
            setup.run();
            ServerProvider.setProvider(setup);
            ClientProvider.setConfig(setup.config());
        } catch (Exception e) {
            e.printStackTrace();
            System.err.println("Configuration failure, HALTING");
            setup = null;
        }
    }

    @AfterSuite
    public void cleanupEnvironment() {
        try {
            cleanUp(setup.coverageOutputPath(), "Basic15.2Test.exec");
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
