package com.perforce.hws.testing;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.testng.Assert;
import org.testng.annotations.Test;

import com.perforce.hws.util.ProcessHelpers;

import java.io.IOException;
import java.nio.file.Path;
import java.nio.file.Paths;

/**
 * Created by tristan on 5/2/16.
 */
public class ExecPhpTest implements ProcessHelpers {

    private static final Logger logger = LoggerFactory.getLogger(ExecPhpTest.class);

    private String script;
    private String clientDir;

    public ExecPhpTest(String clientDir, String script) {
        this.clientDir = clientDir;
        this.script = script;
    }

    @Test
    public void execPhpTest() throws IOException, InterruptedException {
        Path scriptPath = Paths.get(clientDir, script).toAbsolutePath();
        logger.info("Starting test {}", script);
        try {
            String output = execOutOrFail("php", scriptPath.toAbsolutePath().toString());
            logger.debug("Results of test: {}", output);
        } catch (IllegalStateException e) {
            Assert.fail("Test " + script + " failed: " + e.getMessage());
        }
    }
}
