package com.perforce.hws.testing;

import org.testng.annotations.AfterSuite;
import org.testng.annotations.BeforeSuite;

import com.perforce.hws.automation.GitFusionEnvironmentSetup;

import java.io.IOException;

/**
 * Created by tristan on 4/5/16.
 */
public class GitFusionEnvironmentTestSetup implements SuiteCleanupHelpers {

    GitFusionEnvironmentSetup setup = null;

    @BeforeSuite(dependsOnGroups = "log4j")
    public void runGitFusionEnvironmentSetup() {
        try {
            if (setup == null) {
                setup = new GitFusionEnvironmentSetup();
                setup.run();
            }
            ServerProvider.setProvider(setup);
            ClientProvider.setConfig(setup.config());
        } catch (Exception e) {
            e.printStackTrace();
            setup = null;
        }
    }


    @AfterSuite
    public void cleanupEnvironment() {
        try {
            cleanUp(setup.coverageOutputPath(), "BasicGitFusionTest.exec");
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
