package com.perforce.hws.testing;

import org.testng.annotations.AfterSuite;
import org.testng.annotations.BeforeSuite;

import com.perforce.hws.automation.InstallEnvironmentSetup;

import java.io.IOException;

/**
 * Created by tjuricek on 2/16/16.
 */
public class InstallEnvironmentTestSetup implements SuiteCleanupHelpers {

    InstallEnvironmentSetup setup = null;

    @BeforeSuite(dependsOnGroups = "log4j")
    public void runInstallEnvironmentSetup() throws IOException {
        if (setup == null) {
            setup = new InstallEnvironmentSetup();
        }
        try {
            setup.run();
            ServerProvider.setProvider(setup);
            ClientProvider.setConfig(setup.config());
        } catch (Exception e) {
            e.printStackTrace();
            System.err.println("Installation environment not setup correctly, halting");
        }
    }


    @AfterSuite
    public void cleanupEnvironment() {
        try {
            cleanUp(setup.coverageOutputPath(), "InstallEnvironment.exec");
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
