package com.perforce.hws.testing.deployment;

/**
 * Utility methods to dealing with deployment logic in different situations.
 */
public interface DeploymentConventions {

    /**
     * If executing this test in a VMWare shared folder, some commands need to be done differently.
     * Permissions are different, so set the IS_VMWARE_FOLDER (and VMWARE_USER) environment variables.
     *
     * @return
     */
    default boolean isVMWareFolder() {
        return System.getenv("IS_VMWARE_FOLDER") != null;
    }

    /**
     * Your local user account in the VMWare instance, read by the VMWARE_USER environment variable
     *
     * This is needed when you're using VMWare shared folders.
     *
     * @return
     */
    default String vmwareUser() {
        return System.getenv("VMWARE_USER");
    }

}
