package com.perforce.hws.testing.deployment.deb;

import com.perforce.hws.automation.DeploymentCleanup;
import com.perforce.hws.automation.NetworkUtil;
import com.perforce.hws.util.TimingHelpers;
import com.perforce.hws.testing.deployment.ConfigHelpers;
import com.perforce.hwsclient.ApiClient;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.testng.Assert;
import org.testng.annotations.Test;

/**
 * Created by tristan on 5/20/16.
 */
public class ReinstallTests implements ConfigHelpers, DebDeployment, TimingHelpers,
        NetworkUtil {

    static final Logger logger = LoggerFactory.getLogger(ReinstallTests.class);

    @Test
    public void installUninstallReinstallDeb() throws Exception {
        DeploymentCleanup cleanup = new DeploymentCleanup();
        cleanup.run();

        String debBuild = obtainDebBuild();

        installDebFile(debBuild);

        String stopOut = execOutOrFail("service", "helix-ws", "stop");
        logger.info("stop: {}", stopOut);

        String uninstallOut = execOutOrFail("dpkg", "-r", "helix-web-services");
        uninstallOut += execOutOrFail("dpkg", "-P", "helix-web-services");
        logger.info("uninstall: {}", uninstallOut);

        installDebFile(debBuild);

        Assert.assertTrue(waitFor(10, 1000, () -> !isPortAvailable(443)));

        cleanup.run();
    }
}
