package com.perforce.hws.testing.server;

import com.perforce.hws.testing.ClientProvider;
import com.perforce.hwsclient.DefaultApi;
import com.perforce.hwsclient.models.Triggers;

import org.testng.annotations.Test;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import static org.testng.Assert.assertTrue;

/**
 * /p4/:api/triggers tests
 */
public class PerforceTriggersTests {

    @Test(dataProvider = "ProjectClientAsSuper",
            dataProviderClass = ClientProvider.class)
    public void canFetchAndUpdate(DefaultApi api) throws IOException {
        Triggers triggers =
                api.getTriggers("localhost");

        List<String> lines = new ArrayList<>();
        if (triggers.getTriggers() != null) {
            lines.addAll(triggers.getTriggers());
        }

        lines.add("cscheck change-submit //depot/... \"cmd %changelist%\"");

        Triggers toUpdate = new Triggers();
        toUpdate.setTriggers(lines);

        api.updateTriggers("localhost", toUpdate);

        Triggers updated =
                api.getTriggers("localhost");

        assertTrue(updated.getTriggers().contains("cscheck change-submit //depot/... \"cmd %changelist%\""));

        Triggers toClear = new Triggers();

        api.updateTriggers("localhost", toClear);

        Triggers updated2 =
                api.getTriggers("localhost");

        assertTrue(updated2.getTriggers() == null || updated2.getTriggers().isEmpty());
    }
}
